/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 15/10/22.
//

#ifndef FGGL_INTEGRATIONS_LUA_SCRIPT_LUA_MODULE_HPP
#define FGGL_INTEGRATIONS_LUA_SCRIPT_LUA_MODULE_HPP

#include "fggl/modules/module.hpp"
#include "fggl/entity/module.hpp"
#include "fggl/script/engine.hpp"
#include "fggl/data/module.hpp"
#include "fggl/assets/packed/adapter.hpp"


namespace fggl::script::lua {

	constexpr auto MIME_LUA = assets::from_mime("text/lua");
	constexpr auto SCRIPT_LUA = assets::make_asset_type("script/lua");

	struct Lua {
		constexpr static const char* name = "fggl::script::lua";
		constexpr static const std::array<modules::ModuleService, 1> provides = {
			script::ScriptProvider::service
		};
		constexpr static const std::array<modules::ModuleService, 2> depends = {
			data::SERVICE_STORAGE,
			assets::CheckinAdapted::service
		};
		static bool factory(modules::ModuleService name, modules::Services& serviceManager);
	};

} // namespace fggl::script::lua

namespace fggl::script {
	using Lua = lua::Lua;

} // namespace fggl::script

#endif //FGGL_INTEGRATIONS_LUA_SCRIPT_LUA_MODULE_HPP
